#ifndef DT_CONTROL_JOBS_H
#define DT_CONTROL_JOBS_H

#include "common/image.h"
#include "control/control.h"
#include "common/film.h"
#include "develop/develop.h"

typedef struct dt_image_load_t
{
  int32_t imgid;
  dt_image_buffer_t mip;
}
dt_image_load_t;

void dt_image_load_job_run(dt_job_t *job);
void dt_image_load_job_init(dt_job_t *job, int32_t imgid, dt_image_buffer_t mip);

typedef struct dt_film_import1_t
{
  dt_film_t *film;
}
dt_film_import1_t;

void dt_film_import1_run(dt_job_t *job);
void dt_film_import1_init(dt_job_t *job, dt_film_t *film);


typedef struct dt_dev_raw_load_t
{
  dt_develop_t *dev;
  dt_image_t *image;
}
dt_dev_raw_load_t;

void dt_dev_raw_load_job_run(dt_job_t *job);
void dt_dev_raw_load_job_init(dt_job_t *job, dt_develop_t *dev, dt_image_t *image);

typedef struct dt_dev_process_t
{
  dt_develop_t *dev;
}
dt_dev_process_t;
void dt_dev_process_preview_job_run(dt_job_t *job);
void dt_dev_process_preview_job_init(dt_job_t *job, dt_develop_t *dev);
void dt_dev_process_image_job_run(dt_job_t *job);
void dt_dev_process_image_job_init(dt_job_t *job, dt_develop_t *dev);

void dt_dev_export_init(dt_job_t *job);

void dt_control_write_dt_files();
void dt_control_delete_images();
void dt_control_export();

#endif
